diff --git a/gcc/analyzer/impl-4.cc b/gcc/analyzer/impl-4.cc
index b12102c..5089c16 100644
--- a/gcc/analyzer/impl-4.cc
+++ b/gcc/analyzer/impl-4.cc
@@ -3446,25 +4277,363 @@ exploded_graph::prune_path (checker4_path *path,
 	}
 
     }
-  while (changed);
+  while (changed);
+
+  /* Third pass.  If all we're left with is in one function, then
+     filter function entry events.  */
+  if (!path->interprocedural_p ())
+    {
+      // FIXME
+      int idx = path->m_events.length () - 1;
+      while (idx >= 0 && idx < path->m_events.length ())
+	{
+	  checker4_event *base_event = path->m_events[idx];
+	  if (base_event->m_kind == EK_FUNCTION_ENTRY)
+	    {
+	      log ("filtering event %i:"
+		   " function entry for purely intraprocedural path", idx);
+	      path->delete_event (idx);
+	    }
+	  idx--;
+	}
+    }
+}
+
+////////////////////////////////////////////////////////////////////////////
+
+/* exploded_graph's ctor.  */
+
+exploded_graph::exploded_graph (const supergraph &sg, logger *logger,
+				const extrinsic_state &ext_state,
+				const state_purge_map *purge_map,
+				int verbosity)
+: log_user (logger), m_sg (sg), m_ext_state (ext_state),
+  m_purge_map (purge_map),
+  m_diagnostic_manager (logger, verbosity),
+  m_global_stats (m_sg.num_nodes ()),
+  m_PK_AFTER_SUPERNODE_per_snode (m_sg.num_nodes ())
+{
+  m_origin = get_or_create_node (program_point (NULL, NULL, 0, PK_ORIGIN,
+						call_string ()),
+				 program_state (ext_state));
+  for (int i = 0; i < m_sg.num_nodes (); i++)
+    m_PK_AFTER_SUPERNODE_per_snode.safe_push (i);
+}
+
+/* exploded_graph's dtor.  */
+
+exploded_graph::~exploded_graph ()
+{
+  for (function_stat_map_t::iterator iter = m_per_function_stats.begin ();
+       iter != m_per_function_stats.end ();
+       ++iter)
+    delete (*iter).second;
+}
+
+/* Ensure that there is an exploded_node representing an external call to
+   FUN, adding it to the worklist if creating it.
+
+   Add an edge from the origin exploded_node to the function entrypoint
+   exploded_node.  */
+
+void
+exploded_graph::add_function_entry (function *fun)
+{
+  program_point point = program_point::from_function_entry (m_sg, fun);
+  program_state state (m_ext_state);
+  if (state.m_region_model)
+    state.m_region_model->push_frame (fun, NULL);
+
+  add_edge (m_origin, get_or_create_node (point, state), NULL);
+}
+
+/* Get or create an exploded_node for (POINT, STATE).
+   If a new node is created, it is added to the worklist.  */
+
+exploded_node *
+exploded_graph::get_or_create_node (const program_point &point,
+				    const program_state &state)
+{
+  JIT_LOG_FUNC (get_logger ());
+  if (get_logger ())
+    {
+      format f (false);
+      log ("point: %s", point.to_str (f).c_str ());
+      log ("state: %s", state.to_str (m_ext_state).c_str ());
+    }
+
+  auto_cfun sentinel (point.get_function ());
+
+  state.validate ();
+
+  /* Prune state to try to improve the chances of a cache hit,
+     avoiding generating redundant nodes.  */
+  program_state pruned_state = state.prune_for_point (*this, point);
+
+  pruned_state.validate ();
+
+  if (get_logger ())
+    {
+      log ("pruned_state: %s", pruned_state.to_str (m_ext_state).c_str ());
+      if (pruned_state.m_region_model)
+	pruned_state.m_region_model->dump_to_pp (get_logger_pp ());
+    }
+
+  stats *per_fn_stats = get_or_create_function_stats (point.get_function ());
+
+  point_and_state ps (point, pruned_state);
+  if (exploded_node **slot = m_point_and_state_to_node.get (&ps))
+    {
+      /* An exploded_node for PS already exists.  */
+      log ("reused EN: %i", (*slot)->m_index);
+      m_global_stats.m_node_reuse_count++;
+      per_fn_stats->m_node_reuse_count++;
+      return *slot;
+    }
+
+  /* An exploded_node for PS doesn't already exist; create one.  */
+  exploded_node *node = new exploded_node (ps, m_ext_state, m_nodes.length ());
+  add_node (node);
+  m_point_and_state_to_node.put (node->get_key (), node);
+  m_global_stats.m_num_nodes[node->get_point ().m_kind]++;
+  per_fn_stats->m_num_nodes[node->get_point ().m_kind]++;
+
+  if (node->get_point ().m_kind == PK_AFTER_SUPERNODE)
+    m_PK_AFTER_SUPERNODE_per_snode[point.get_supernode ()->m_index]++;
+
+  if (get_logger ())
+    {
+      format f (false);
+      log ("created EN: %i", node->m_index);
+      log ("point: %s", point.to_str (f).c_str ());
+      log ("pruned_state: %s", pruned_state.to_str (m_ext_state).c_str ());
+    }
+
+  if (pruned_state.m_region_model)
+    {
+      pretty_printer pp;
+      pp_printf (&pp, "%s.EN-%i.rmodel.dot",
+		 dump_base_name, node->m_index);
+      pruned_state.m_region_model->dump_dot (pp_formatted_text (&pp));
+    }
+
+  /* Add the new node to the worlist.  */
+  m_worklist.safe_push (node);
+  return node;
+}
+
+/* Add an exploded_edge from SRC to DEST, recording its association
+   with SEDGE (which may be NULL).  */
+
+void
+exploded_graph::add_edge (exploded_node *src, exploded_node *dest,
+			  const superedge *sedge)
+{
+  exploded_edge *e = new exploded_edge (src, dest, sedge);
+  digraph::add_edge (e);
+  src->m_succs.safe_push (e);
+}
+
+/* The main loop of the analysis.
+   Pop freshly-created exploded_nodes from the worklist, calling
+   process_node on them to explore the <point, state> graph.
+   Add edges to their successors, potentially creating new successors
+   (which are also added to the worklist).  */
+
+void
+exploded_graph::process_worklist ()
+{
+  JIT_LOG_SCOPE (get_logger ());
+  auto_client_timevar tv ("exploded_graph::process_worklist");
+
+  while (m_worklist.length () > 0)
+    {
+      exploded_node *node = m_worklist.pop ();
+      process_node (node);
+
+      /* FIXME: make this less ad-hoc?  e.g. a param */
+      /* we use exit rather than entry since there can be multiple
+	 entry ENs, one per phi; the number of PK_AFTER_SUPERNODE ought
+	 to be equivalent to the number of supernodes multiplied by the
+	 number of states.  */
+      // FIXME: do per function
+      if (m_global_stats.m_num_nodes[PK_AFTER_SUPERNODE]> m_sg.num_nodes () * 5)
+	{
+	  log ("bailing out; too many nodes");
+	  warning (0, "analysis bailed out early (%i nodes)",
+		   m_global_stats.m_num_nodes[PK_AFTER_SUPERNODE]);
+	  // TODO: better location??
+	  return;
+	}
+    }
+}
+
+/* The core of exploded_graph::process_worklist (the main analysis loop),
+   handling one node in the worklist.
+
+   Get successor <point, state> pairs for NODE, calling get_or_create on
+   them, and adding an exploded_edge to each successors.
+
+   Freshly-created nodes will be added to the worklist.  */
+
+void
+exploded_graph::process_node (exploded_node *node)
+{
+  JIT_LOG_FUNC_1 (get_logger (), "EN: %i", node->m_index);
+
+  auto_cfun sentinel (node->get_function ());
+
+  const program_point &point = node->get_point ();
+  const program_state &state = node->get_state ();
+  if (get_logger ())
+    {
+      format f (false);
+      log ("point: %s, state: %s",
+	   point.to_str (f).c_str (),
+	   state.to_str (m_ext_state).c_str ());
+    }
+
+  switch (point.m_kind)
+    {
+    default:
+      gcc_unreachable ();
+    case PK_ORIGIN:
+      /* This node exists to simplify finding the shortest path
+	 to an exploded_node.  */
+      break;
+
+    case PK_BEFORE_SUPERNODE:
+      {
+	program_state next_state (state);
+
+	for (gphi_iterator gpi
+	       = const_cast<supernode *>(node->get_supernode ())->start_phis ();
+	     !gsi_end_p (gpi); gsi_next (&gpi))
+	  {
+	    gphi *phi = gpi.phi ();
+
+	    const cfg_superedge *last_cfg_superedge
+	      = point.m_from_edge->dyn_cast_cfg_superedge ();
+	    gcc_assert (last_cfg_superedge);
+	    // FIXME: this ought to be an as_a<>
+
+	    tree src = last_cfg_superedge->get_phi_arg (phi);
+	    tree lhs = gimple_phi_result (phi);
+
+	    /* Update next_state based on phi.  */
+	    node->on_assignment (*this,
+				 point.make_path_var (lhs),
+				 point.make_path_var (src),
+				 state,
+				 &next_state);
+
+	    if (next_state.m_region_model)
+	      {
+		bool is_back_edge = last_cfg_superedge->back_edge_p ();
+		next_state.m_region_model->handle_phi (lhs, src, is_back_edge);
+	      }
+	  }
+
+	if (point.m_supernode->m_stmts.length () > 0)
+	  {
+	    program_point next_point
+	      = program_point::before_stmt (point.m_supernode, 0,
+					    point.m_call_string);
+	    exploded_node *next
+	      = get_or_create_node (next_point, next_state);
+	    add_edge (node, next, NULL);
+	  }
+	else
+	  {
+	    program_point next_point
+	      = program_point::after_supernode (point.m_supernode,
+						point.m_call_string);
+	    exploded_node *next = get_or_create_node (next_point, next_state);
+	    add_edge (node, next, NULL);
+	  }
+      }
+      break;
+    case PK_BEFORE_STMT:
+      {
+	// TODO: update state based on stmt!
+	program_point next_point
+	  = program_point::after_stmt (point.m_supernode, point.m_stmt_idx,
+				       point.m_call_string);
+	program_state next_state = node->on_stmt (*this);
+	exploded_node *next = get_or_create_node (next_point, next_state);
+	add_edge (node, next, NULL);
+      }
+      break;
+    case PK_AFTER_STMT:
+      {
+	unsigned next_idx = point.m_stmt_idx + 1;
+	if (next_idx < point.m_supernode->m_stmts.length ())
+	  {
+	    program_point next_point
+	      = program_point::before_stmt (point.m_supernode, next_idx,
+					    point.m_call_string);
+	    exploded_node *next
+	      = get_or_create_node (next_point, state);
+	    add_edge (node, next, NULL);
+	  }
+	else
+	  {
+	    program_point next_point
+	      = program_point::after_supernode (point.m_supernode,
+						point.m_call_string);
+	    exploded_node *next = get_or_create_node (next_point, state);
+	    add_edge (node, next, NULL);
+	  }
+      }
+      break;
+    case PK_AFTER_SUPERNODE:
+      {
+	/* If this is an EXIT BB, detect leaks.  */
+	if (point.m_supernode->return_p ())
+	  node->detect_leaks (*this);
+
+	/* Traverse into successors of the supernode.  */
+	int i;
+	superedge *succ;
+	FOR_EACH_VEC_ELT (point.m_supernode->m_succs, i, succ)
+	  {
+	    log ("considering SN: %i -> SN: %i",
+		 succ->m_src->m_index, succ->m_dest->m_index);
+
+	    program_point next_point
+	      = program_point::before_supernode (succ->m_dest, succ,
+						 point.m_call_string);
+	    program_state next_state (state);
+
+	    if (!node->on_edge (*this, succ, &next_point, &next_state))
+	      {
+		log ("skipping impossible edge to SN: %i",
+		     succ->m_dest->m_index);
+		continue;
+	      }
+
+	    exploded_node *next = get_or_create_node (next_point, next_state);
+	    add_edge (node, next, succ);
+	  }
+      }
+      break;
+    }
+}
 
-  /* Third pass.  If all we're left with is in one function, then
-     filter function entry events.  */
-  if (!path->interprocedural_p ())
+/* FIXME.  */
+
+stats *
+exploded_graph::get_or_create_function_stats (function *fn)
+{
+  if (stats **slot = m_per_function_stats.get (fn))
+    return *slot;
+  else
     {
-      // FIXME
-      int idx = path->m_events.length () - 1;
-      while (idx >= 0 && idx < path->m_events.length ())
-	{
-	  checker4_event *base_event = path->m_events[idx];
-	  if (base_event->m_kind == EK_FUNCTION_ENTRY)
-	    {
-	      log ("filtering event %i:"
-		   " function entry for purely intraprocedural path", idx);
-	      path->delete_event (idx);
-	    }
-	  idx--;
-	}
+      int num_supernodes = fn ? n_basic_blocks_for_fn (fn) : 0;
+      // FIXME: ^^^ not quite the num supernodes, but nearly
+      stats *new_stats = new stats (num_supernodes);
+      m_per_function_stats.put (fn, new_stats);
+      return new_stats;
     }
 }
 
@@ -3476,13 +4645,69 @@ exploded_graph::log_stats () const
   if (!get_logger ())
     return;
 
+  JIT_LOG_SCOPE (get_logger ());
+
   log ("m_sg.num_nodes (): %i", m_sg.num_nodes ());
   log ("m_nodes.length (): %i", m_nodes.length ());
-  for (int i = 0; i < NUM_POINT_KINDS; i++)
-    log ("m_num_nodes[%s]: %i",
-	 point_kind_to_string (static_cast <enum point_kind> (i)),
-	 m_num_nodes[i]);
-  log ("m_node_reuse_count: %i", m_node_reuse_count);
+  log ("m_edges.length (): %i", m_edges.length ());
+
+  log ("global stats:");
+  m_global_stats.log (get_logger ());
+
+  for (function_stat_map_t::iterator iter = m_per_function_stats.begin ();
+       iter != m_per_function_stats.end ();
+       ++iter)
+    {
+      function *fn = (*iter).first;
+      log_scope s (get_logger (), function_name (fn));
+      (*iter).second->log (get_logger ());
+    }
+}
+
+void
+exploded_graph::dump_stats (FILE *out) const
+{
+  fprintf (out, "m_sg.num_nodes (): %i\n", m_sg.num_nodes ());
+  fprintf (out, "m_nodes.length (): %i\n", m_nodes.length ());
+  fprintf (out, "m_edges.length (): %i\n", m_edges.length ());
+
+  fprintf (out, "global stats:\n");
+  m_global_stats.dump (out);
+
+  for (function_stat_map_t::iterator iter = m_per_function_stats.begin ();
+       iter != m_per_function_stats.end ();
+       ++iter)
+    {
+      function *fn = (*iter).first;
+      fprintf (out, "function: %s\n", function_name (fn));
+      (*iter).second->dump (out);
+    }
+
+  fprintf (out, "PK_AFTER_SUPERNODE per supernode:\n");
+  for (int i = 0; i < m_PK_AFTER_SUPERNODE_per_snode.length (); i++)
+    fprintf (out, "  SN %i: %3i\n", i, m_PK_AFTER_SUPERNODE_per_snode[i]);
+}
+
+void
+exploded_graph::dump_states_for_supernode (FILE *out,
+					   const supernode *snode) const
+{
+  fprintf (out, "PK_AFTER_SUPERNODE nodes for SN: %i\n", snode->m_index);
+  int i;
+  dnode *node;
+  int state_idx = 0;
+  FOR_EACH_VEC_ELT (m_nodes, i, node)
+    {
+      exploded_node *enode = (exploded_node *)node;
+      const supernode *iter_snode = enode->get_supernode ();
+      if (enode->get_point ().m_kind == PK_AFTER_SUPERNODE
+	  && iter_snode == snode)
+	fprintf (out, "state %i: EN: %i\n  %s\n",
+		 state_idx++, enode->m_index,
+		 enode->get_state ().to_str (m_ext_state).c_str ());
+    }
+  fprintf (out, "#exploded_node for PK_AFTER_SUPERNODE for SN: %i = %i\n",
+	   snode->m_index, state_idx);
 }
 
 ////////////////////////////////////////////////////////////////////////////
@@ -3525,6 +4750,8 @@ shortest_paths::shortest_paths (const exploded_graph &eg)
   m_dist (eg.m_nodes.length ()),
   m_prev (eg.m_nodes.length ())
 {
+  auto_client_timevar tv ("shortest_paths");
+
   auto_vec<int> queue (eg.m_nodes.length ());
 
   for (unsigned i = 0; i < eg.m_nodes.length (); i++)
@@ -3809,7 +5036,13 @@ public:
   function_call_string_cluster (function *fun, call_string cs)
   : m_fun (fun), m_cs (cs) {}
 
-  // TODO: dtor
+  ~function_call_string_cluster ()
+  {
+    for (map_t::iterator iter = m_map.begin ();
+	 iter != m_map.end ();
+	 ++iter)
+      delete (*iter).second;
+  }
 
   void dump_dot (graphviz_out *gv) const FINAL OVERRIDE
   {
@@ -3925,7 +5158,10 @@ class root_cluster : public en_cluster
 public:
   ~root_cluster ()
   {
-    // TODO: delete the function_cluster instances in the map
+    for (map_t::iterator iter = m_map.begin ();
+	 iter != m_map.end ();
+	 ++iter)
+      delete (*iter).second;
   }
 
   void dump_dot (graphviz_out *gv) const FINAL OVERRIDE
@@ -3979,6 +5215,456 @@ private:
 
 ////////////////////////////////////////////////////////////////////////////
 
+/* FIXME.  */
+
+state_purge_map::state_purge_map (const supergraph &sg,
+				  logger *logger)
+: log_user (logger), m_sg (sg)
+{
+  JIT_LOG_FUNC (logger);
+
+  auto_client_timevar tv ("state_purge_map ctor");
+
+  cgraph_node *node;
+  FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (node)
+  {
+    function *fun = node->get_fun ();
+    if (logger)
+      log ("function: %s", function_name (fun));
+    tree var;
+    unsigned int i;;
+    FOR_EACH_SSA_NAME (i, var, fun)
+      m_map.put (var, new state_purge_per_ssa_name (*this, var, fun));
+  }
+}
+
+/* FIXME.  */
+
+state_purge_map::~state_purge_map ()
+{
+  for (iterator iter = m_map.begin (); iter != m_map.end (); ++iter)
+    delete (*iter).second;
+}
+
+/* state_purge_per_ssa_name's ctor.
+
+   Locate all uses of VAR within FUN.
+   Walk backwards from each use, marking program points, until
+   we reach the def stmt, populating m_points_needing_var.
+
+   We have to track program points rather than
+   just stmts since there could be empty basic blocks on the way.  */
+
+state_purge_per_ssa_name::state_purge_per_ssa_name (const state_purge_map &map,
+						    tree var,
+						    function *fun)
+: m_var (var)
+{
+  JIT_LOG_FUNC (map.get_logger ());
+
+  map.log ("SSA name: %qE", var);
+  if (map.get_logger ())
+    {
+      /* Show def stmt.  */
+      gimple *def_stmt = SSA_NAME_DEF_STMT (var);
+      pretty_printer pp;
+      pp_gimple_stmt_1 (&pp, def_stmt, 0, (dump_flags_t)0);
+      map.log ("def stmt: %s", pp_formatted_text (&pp));
+    }
+
+  /* The worklist for the traversal.
+     FIXME: worklist can't be a vec<program_point>; we can't have a
+     vec<program_point> because vec<T> require T to be a POD.
+     Hence (annoyingly) we dynamically allocate.  */
+  auto_vec<program_point *> worklist;
+
+  /* Add all immediate uses of var to the worklist.
+     Compare with debug_immediate_uses.  */
+  imm_use_iterator iter;
+  use_operand_p use_p;
+  FOR_EACH_IMM_USE_FAST (use_p, iter, var)
+    {
+      if (USE_STMT (use_p))
+	{
+	  gimple *use_stmt = USE_STMT (use_p);
+	  if (map.get_logger ())
+	    {
+	      pretty_printer pp;
+	      pp_gimple_stmt_1 (&pp, use_stmt, 0, (dump_flags_t)0);
+	      map.log ("used by stmt: %s", pp_formatted_text (&pp));
+	    }
+
+	  const supernode *snode
+	    = map.m_sg.get_node_for_block (use_stmt->bb);
+
+	  /* If it's a use within a phi node, then we care about
+	     which in-edge we came from.  */
+	  if (use_stmt->code == GIMPLE_PHI)
+	    {
+	      for (gphi_iterator gpi
+		     = const_cast<supernode *> (snode)->start_phis ();
+		   !gsi_end_p (gpi); gsi_next (&gpi))
+		{
+		  gphi *phi = gpi.phi ();
+		  if (phi == use_stmt)
+		    {
+		      /* Find arguments (and thus in-edges) which use VAR.  */
+		      for (unsigned arg_idx = 0;
+			   arg_idx < gimple_phi_num_args (phi);
+			   ++arg_idx)
+			{
+			  if (var == gimple_phi_arg (phi, arg_idx)->def)
+			    {
+			      edge in_edge = gimple_phi_arg_edge (phi, arg_idx);
+			      const superedge *in_sedge
+				= map.m_sg.get_edge_for_cfg_edge (in_edge);
+			      program_point point
+				= program_point::before_supernode
+				(snode, in_sedge, call_string ());
+			      add_to_worklist (point, &worklist,
+					       map.get_logger ());
+			      m_points_needing_var.add (point);
+			    }
+			}
+		    }
+		}
+	    }
+	  else
+	    {
+	      program_point point = before_use_stmt (map, use_stmt);
+	      add_to_worklist (point, &worklist, map.get_logger ());
+	      m_points_needing_var.add (point);
+
+	      /* We also need to add uses for conditionals and switches,
+		 where the stmt "happens" at the after_supernode, for filtering
+		 the out-edges.  */
+	      if (use_stmt == snode->get_last_stmt ())
+		{
+		  program_point point
+		    = program_point::after_supernode (snode, call_string ());
+		  add_to_worklist (point, &worklist, map.get_logger ());
+		  m_points_needing_var.add (point);
+		}
+	    }
+	}
+    }
+
+  /* Process worklist by walking backwards until we reach the def stmt.  */
+  {
+    log_scope s (map.get_logger (), "processing worklist");
+    while (worklist.length () > 0)
+      {
+	program_point *point_ptr = worklist.pop ();
+	program_point point (*point_ptr);
+	process_point (*point_ptr, &worklist, map.get_logger ());
+	delete point_ptr;
+    }
+  }
+
+  if (map.get_logger ())
+    {
+      map.log ("%qE is needed to process:", var);
+      for (point_set_t::iterator iter = m_points_needing_var.begin ();
+	   iter != m_points_needing_var.end ();
+	   ++iter)
+	{
+	  format f (false);
+	  map.log ("  point: %s", (*iter).to_str (f).c_str ());
+	}
+    }
+}
+
+/* FIXME.  */
+
+bool
+state_purge_per_ssa_name::needed_at_point_p (const program_point &point) const
+{
+  return const_cast <point_set_t &> (m_points_needing_var).contains (point);
+}
+
+/* FIXME.  */
+
+program_point
+state_purge_per_ssa_name::before_use_stmt (const state_purge_map &map,
+					   const gimple *use_stmt)
+{
+  gcc_assert (use_stmt->code != GIMPLE_PHI); // FIXME: for now
+#if 0
+  if (stmt->code == GIMPLE_PHI)
+    {
+      const supernode *supernode = sg.get_node_for_block (stmt->bb);
+      return before_supernode (supernode, from_edge, call_string);
+    }
+  else
+#endif
+    {
+      const supernode *supernode = map.m_sg.get_supernode_for_stmt (use_stmt);
+      unsigned int stmt_idx = supernode->get_stmt_index (use_stmt);
+      return program_point::before_stmt (supernode, stmt_idx, call_string ());
+    }
+}
+
+/* FIXME.  */
+
+void
+state_purge_per_ssa_name::add_to_worklist (const program_point &point,
+					   auto_vec<program_point *> *worklist,
+					   logger *logger)
+{
+  JIT_LOG_FUNC (logger);
+  if (logger)
+    {
+      format f (false);
+      logger->log ("point: %s", point.to_str (f).c_str ());
+    }
+
+  if (m_points_needing_var.contains (point))
+    {
+      if (logger)
+	logger->log ("already seen");
+    }
+  else
+    {
+      if (logger)
+	logger->log ("not seen; adding to worklist");
+      worklist->safe_push (new program_point (point));
+    }
+}
+
+/* Process POINT, popped from WORKLIST.
+   Iterate over predecessors of POINT, adding to WORKLIST.  */
+
+void
+state_purge_per_ssa_name::process_point (const program_point &point,
+					 auto_vec<program_point *> *worklist,
+					 logger *logger)
+{
+  JIT_LOG_FUNC (logger);
+  if (logger)
+    {
+      format f (false);
+      logger->log ("considering point: %s", point.to_str (f).c_str ());
+    }
+
+  gimple *def_stmt = SSA_NAME_DEF_STMT (m_var);
+
+  m_points_needing_var.add (point);
+
+  const supernode *snode = point.get_supernode ();
+
+  switch (point.m_kind)
+    {
+    default:
+      gcc_unreachable ();
+
+    case PK_ORIGIN:
+      break;
+
+    case PK_BEFORE_SUPERNODE:
+      {
+	for (gphi_iterator gpi
+	       = const_cast<supernode *> (snode)->start_phis ();
+	     !gsi_end_p (gpi); gsi_next (&gpi))
+	  {
+	    gphi *phi = gpi.phi ();
+	    if (phi == def_stmt)
+	      {
+		if (logger)
+		  logger->log ("def stmt within phis; terminating");
+		return;
+	      }
+	  }
+
+	/* Add given pred to worklist.  */
+	if (point.m_from_edge)
+	  {
+	    if (point.m_from_edge->m_src)
+	      add_to_worklist
+		(program_point::after_supernode (point.m_from_edge->m_src,
+						 call_string ()),
+		 worklist, logger);
+	  }
+	else
+	  gcc_assert (snode->entry_p ());
+      }
+      break;
+
+    case PK_BEFORE_STMT:
+      {
+	if (def_stmt == point.get_stmt ())
+	  {
+	    if (logger)
+	      logger->log ("def stmt; terminating");
+	    return;
+	  }
+	if (point.m_stmt_idx > 0)
+	  add_to_worklist (program_point::after_stmt (snode,
+						      point.m_stmt_idx - 1,
+						      call_string ()),
+			   worklist, logger);
+	else
+	{
+	  /* Add before_supernode to worklist.  This captures the in-edge,
+	     so we have to do it once per in-edge.  */
+	  unsigned i;
+	  superedge *pred;
+	  FOR_EACH_VEC_ELT (snode->m_preds, i, pred)
+	    add_to_worklist (program_point::before_supernode (snode,
+							      pred,
+							      call_string ()),
+			     worklist, logger);
+	}
+      }
+      break;
+
+    case PK_AFTER_STMT:
+      add_to_worklist (program_point::before_stmt (snode,
+						   point.m_stmt_idx,
+						   call_string ()),
+		       worklist, logger);
+      break;
+
+    case PK_AFTER_SUPERNODE:
+      {
+	if (snode->m_stmts.length ())
+	  add_to_worklist
+	    (program_point::after_stmt (snode,
+					snode->m_stmts.length () - 1,
+					call_string ()),
+	     worklist, logger);
+	else
+	  {
+	    /* Add before_supernode to worklist.  This captures the in-edge,
+	       so we have to do it once per in-edge.  */
+	    unsigned i;
+	    superedge *pred;
+	    FOR_EACH_VEC_ELT (snode->m_preds, i, pred)
+	      add_to_worklist (program_point::before_supernode (snode,
+								pred,
+								call_string ()),
+			       worklist, logger);
+	    /* If no preds and it's the initial BB, add it, to ensure that we
+	       have "before supernode" for the initial ENTRY block, and don't
+	       erroneously purge SSA names for initial values of parameters.  */
+	    if (snode->entry_p ()
+		&& snode->m_preds.length () == 0)
+	      {
+		add_to_worklist
+		  (program_point::before_supernode (snode,
+						    NULL,
+						    call_string ()),
+		   worklist, logger);
+	      }
+	  }
+      }
+      break;
+    }
+}
+
+/* FIXME.  */
+
+class state_purge_annotator  : public dot_annotator
+{
+public:
+  state_purge_annotator (const state_purge_map *map) : m_map (map) {}
+
+  void add_node_annotations (pretty_printer *pp ATTRIBUTE_UNUSED,
+			     const supernode &n ATTRIBUTE_UNUSED)
+    const FINAL OVERRIDE
+  {
+    if (m_map == NULL)
+      return;
+
+#if 0
+    //pp_printf (pp, "FIXME: node annotation");
+    pp_printf (pp, "annotation_for_node_%i", n.m_index);
+    pp_printf (pp, " [shape=%s,style=filled,fillcolor=%s,label=\"",
+	       "record", "lightblue");
+    pp_left_brace (pp);
+    pp_write_text_to_stream (pp);
+
+    // TODO: which in-edge?
+    program_point before_supernode
+      (program_point::before_supernode (&n, call_string ()));
+
+    for (state_purge_map::iterator iter = m_map.begin ();
+	 iter != m_map.end ();
+	 ++iter)
+      {
+	tree var = (*iter).first;
+	state_purge_per_ssa_name *per_var_data = (*iter).second;
+	if (per_var_data->needed_at_point_p (before_supernode))
+	  pp_printf (pp, "%qE needed here", var);
+	else
+	  pp_printf (pp, "%qE not needed here", var);
+	pp_newline (pp);
+      }
+
+    pp_right_brace (pp);
+
+    pp_string (pp, "\"];\n\n");
+    pp_flush (pp);
+#endif
+  }
+
+  void add_stmt_annotations (pretty_printer *pp ATTRIBUTE_UNUSED,
+			     const gimple *stmt ATTRIBUTE_UNUSED)
+    const FINAL OVERRIDE
+  {
+    if (m_map == NULL)
+      return;
+
+    if (stmt->code == GIMPLE_PHI)
+      return;
+
+    pp_newline (pp);
+
+    const supernode *supernode = m_map->m_sg.get_supernode_for_stmt (stmt);
+    unsigned int stmt_idx = supernode->get_stmt_index (stmt);
+    program_point before_stmt
+      (program_point::before_stmt (supernode, stmt_idx, call_string ()));
+
+    auto_vec<tree> needed;
+    auto_vec<tree> not_needed;
+    for (state_purge_map::iterator iter = m_map->begin ();
+	 iter != m_map->end ();
+	 ++iter)
+      {
+	tree var = (*iter).first;
+	state_purge_per_ssa_name *per_var_data = (*iter).second;
+	if (per_var_data->needed_at_point_p (before_stmt))
+	  needed.safe_push (var);
+	else
+	  not_needed.safe_push (var);
+      }
+
+    tree var;
+    unsigned i;
+    pp_printf (pp, "needed here: {");
+    FOR_EACH_VEC_ELT (needed, i, var)
+      {
+	if (i > 0)
+	  pp_string (pp, ", ");
+	pp_printf (pp, "%qE", var);
+      }
+    pp_printf (pp, "}");
+    pp_newline (pp);
+    pp_printf (pp, "not needed here: {");
+    FOR_EACH_VEC_ELT (not_needed, i, var)
+      {
+	if (i > 0)
+	  pp_string (pp, ", ");
+	pp_printf (pp, "%qE", var);
+      }
+    pp_newline (pp);
+  }
+
+private:
+  const state_purge_map *m_map;
+};
+
+////////////////////////////////////////////////////////////////////////////
+
 #if 0
 /* FIXME.  */
 
@@ -4005,14 +5691,25 @@ impl_run_checkers (logger *logger)
   /* Create the supergraph.  */
   supergraph sg (logger);
 
-  if (1)
+  state_purge_map *purge_map = NULL;
+
+  if (flag_analyzer_state_purge)
+      purge_map = new state_purge_map (sg, logger);
+
+  if (flag_dump_analyzer_supergraph)
     {
+      auto_client_timevar tv ("writing .supergraph.dot");
+      state_purge_annotator a (purge_map);
       char *filename = concat (dump_base_name, ".supergraph.dot", NULL);
-      sg.dump_dot (filename, (enum supergraph_dot_flags)0);
+      sg.dump_dot (filename, (enum supergraph_dot_flags)0, &a);
       free (filename);
     }
 
-  // TODO: selftest for auto_delete_vec
+#if 0
+  // FIXME: early exit (while debugging state_purge_map)
+  return;
+#endif
+
   auto_delete_vec <state_machine> checkers;
   make_checkers (checkers, logger);
 
@@ -4023,11 +5720,12 @@ impl_run_checkers (logger *logger)
       FOR_EACH_VEC_ELT (checkers, i, sm)
 	logger->log ("checkers[%i]: %s", i, sm->get_name ());
     }
-  //engine e (sg, sm, logger, analyzer_verbosity);
 
-  // TODO: add initial nodes
-  impl_4::exploded_graph eg (sg, logger, checkers, analyzer_verbosity);
+  /* The exploded graph.  */
+  impl_4::exploded_graph eg (sg, logger, checkers, purge_map,
+			     analyzer_verbosity);
 
+  /* Add entrypoints to the graph for externally-callable functions.  */
   cgraph_node *node;
   FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (node)
   {
@@ -4041,10 +5739,12 @@ impl_run_checkers (logger *logger)
     eg.add_function_entry (fun);
   }
 
+  /* Now process the worklist, exploring the <point, state> graph.  */
   eg.process_worklist ();
 
-  if (1)
+  if (flag_dump_analyzer_exploded_graph)
     {
+      auto_client_timevar tv ("writing .eg.dot");
       char *filename
 	= concat (dump_base_name, ".eg.dot", NULL);
       root_cluster c;
@@ -4052,7 +5752,12 @@ impl_run_checkers (logger *logger)
       free (filename);
     }
 
+  /* Now emit any saved diagnostics.  */
+  eg.get_diagnostic_manager ().emit_saved_diagnostics (eg);
+
   eg.log_stats ();
+
+  delete purge_map;
 }
 
 } // namespace impl_4
@@ -4107,7 +5812,7 @@ test_sm_state_map ()
 
   /* Test setting states on path_var instances directly.  */
   {
-    impl_4::sm_state_map map;
+    impl_4::sm_state_map<path_var> map;
     ASSERT_TRUE (map.is_empty_p ());
     ASSERT_EQ (map.get_state (x0), 0);
 
@@ -4127,7 +5832,7 @@ test_sm_state_map ()
 
   /* Test setting states via equivalence classes.  */
   {
-    impl_4::sm_state_map map;
+    impl_4::sm_state_map<path_var> map;
     ASSERT_TRUE (map.is_empty_p ());
     ASSERT_EQ (map.get_state (x0), 0);
     ASSERT_EQ (map.get_state (y0), 0);
@@ -4146,9 +5851,9 @@ test_sm_state_map ()
 
   /* Test equality and hashing.  */
   {
-    impl_4::sm_state_map map0;
-    impl_4::sm_state_map map1;
-    impl_4::sm_state_map map2;
+    impl_4::sm_state_map<path_var> map0;
+    impl_4::sm_state_map<path_var> map1;
+    impl_4::sm_state_map<path_var> map2;
 
     ASSERT_EQ (map0.hash (), map1.hash ());
     ASSERT_EQ (map0, map1);
